Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-1.6-compat
%define gcj_support     0

%define eclipse_name    eclipse
%define eclipse_base    %{_libdir}/%{eclipse_name}
%define install_loc     %{_datadir}/eclipse/dropins
%define core_plugin_jar %{install_loc}/subclipse/eclipse/plugins/org.tigris.subversion.subclipse.core_%{version}.jar
%define core_plugin_dir %{install_loc}/subclipse/eclipse/plugins/org.tigris.subversion.subclipse.core_%{version}

%define disable_javahl  0
%if 0%{?fedora} == 6
%define disable_javahl  1
%endif
%if 0%{?rhel} == 5
%define disable_javahl  1
%endif

%define javahl_dir %{_javadir}

%if 0%{?fedora} >= 8
%define javahl_dir %{_javadir}

%endif

Name:           eclipse-subclipse
Version:        1.2.4
Release:        alt2_12jpp6
Summary:        Subversion Eclipse plugin

Group:          Editors
License:        EPL
URL:            http://subclipse.tigris.org/
Source0:        subclipse-%{version}.tgz
# Script to fetch the source code
# the new source tarball does not includes the book feature and the layout is
# different than the source repository
Source10:       subclipse-fetch-1.2.4.sh
# Disable javahl support temporaly until apparent classloader problem is fixed
Patch0:         eclipse-subclipse-1.2.2-default-svnkit.patch
Patch1:         eclipse-subclipse-1.2.4-plugin-classpath.patch


BuildRequires: ant
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: coreutils
BuildRequires: eclipse-pde
%if %{gcj_support}
BuildRequires: gcc-java >= 4.0.2
BuildRequires: java-gcj-compat-devel >= 1.0.33
Requires(post): java-gcj-compat >= 1.0.33
Requires(postun): java-gcj-compat >= 1.0.33
%else
%endif

%if %{gcj_support}
%else
BuildArch:              noarch
%endif

Requires: eclipse-platform

BuildRequires: subversion-javahl >= 1.3.1
Requires: subversion-javahl >= 1.3.1
BuildRequires: svnkit >= 1.1.2
Requires: svnkit >= 1.1.2
BuildRequires: ganymed-ssh2 >= 209
Requires: ganymed-ssh2 >= 209

%package book
Summary:        Subversion book
Group:          Development/Other
Requires: %{name} = %{version}-%{release}


%description
Subclipse is an Eclipse plugin that adds Subversion integration to the Eclipse
IDE.

%description book
The Subversion book as an Eclipse documentation plugin.


%prep
%setup -q -n subclipse-%{version}
%if 0%{disable_javahl}
%patch0 -p1 
%endif
%patch1 -p1 

# delete the jars that are in the archive
rm svnClientAdapter/lib/svnjavahl.jar
ln -s %{javahl_dir}/svn-javahl.jar svnClientAdapter/lib/svnjavahl.jar
rm -f svnClientAdapter/lib/svnkit.jar
ln -s %{_javadir}/svnkit.jar svnClientAdapter/lib/svnkit.jar
rm -f svnClientAdapter/lib/ganymed.jar
ln -s %{_javadir}/ganymed-ssh2.jar svnClientAdapter/lib/ganymed.jar

rm -f subclipse/core/lib/svnjavahl.jar
ln -s %{javahl_dir}/svn-javahl.jar subclipse/core/lib/svnjavahl.jar
rm -f subclipse/core/lib/svnClientAdapter.jar
# svnClientAdapter.jar is copied after being built
rm -f subclipse/core/lib/svnkit.jar
ln -s %{_javadir}/svnkit.jar subclipse/core/lib/svnkit.jar
rm -f subclipse/core/lib/ganymed.jar
ln -s %{_javadir}/ganymed-ssh2.jar subclipse/core/lib/ganymed.jar


%build
# ---------------------------------
# building svnClientAdapter
pushd svnClientAdapter
%{ant} svnClientAdapter.jar
popd

# copying svnClientAdapter inside subclipse module
cp svnClientAdapter/build/lib/svnClientAdapter.jar subclipse/core/lib/svnClientAdapter.jar

# ---------------------------------
# building subclipse
pushd subclipse

%{eclipse_base}/buildscripts/pdebuild -f org.tigris.subversion.subclipse
%{eclipse_base}/buildscripts/pdebuild -f org.tigris.subversion.book

# returning to base build directory
popd

# Link source files to fix -debuginfo generation.
rm -rf subclipse/org
mkdir -p subclipse/org/tigris/subversion
ln -s $(pwd)/svnClientAdapter/src/main/org/tigris/subversion/svnclientadapter subclipse/org/tigris/subversion
mkdir -p subclipse/org/tigris/subversion/subclipse
ln -s $(pwd)/subclipse/core/src/org/tigris/subversion/subclipse/core subclipse/org/tigris/subversion/subclipse
ln -s $(pwd)/subclipse/ui/src/org/tigris/subversion/subclipse/ui subclipse/org/tigris/subversion/subclipse

%install
install -d -m 755 $RPM_BUILD_ROOT%{install_loc}

installDir=$RPM_BUILD_ROOT%{install_loc}/subclipse
install -d -m 755 $installDir
install -d -m 755 ${installDir}-book
pushd subclipse
unzip -q -d $installDir build/rpmBuild/org.tigris.subversion.subclipse.zip
unzip -q -d ${installDir}-book build/rpmBuild/org.tigris.subversion.book.zip
popd

# repacking core plugin as a directory based plugin, needed in order to replace some jars with symlinks
mkdir $RPM_BUILD_ROOT%{core_plugin_dir}
unzip -q -d $RPM_BUILD_ROOT%{core_plugin_dir} $RPM_BUILD_ROOT%{core_plugin_jar}
rm $RPM_BUILD_ROOT%{core_plugin_jar}
# packaging .class files as a jar file
jar -cf $RPM_BUILD_ROOT%{core_plugin_dir}/lib/subclipse-core.jar -C $RPM_BUILD_ROOT%{core_plugin_dir} org
rm -rf $RPM_BUILD_ROOT%{core_plugin_dir}/org

# removing core plugin internal jars
rm -f $RPM_BUILD_ROOT%{core_plugin_dir}/lib/svnjavahl.jar
rm -f $RPM_BUILD_ROOT%{core_plugin_dir}/lib/svnkit.jar
rm -f $RPM_BUILD_ROOT%{core_plugin_dir}/lib/ganymed.jar

%if %{gcj_support}
  aot-compile-rpm
%endif

# We need to setup the symlink because the ant copy task doesn't preserve symlinks
# TODO file a bug about this
ln -s %{javahl_dir}/svn-javahl.jar $RPM_BUILD_ROOT%{core_plugin_dir}/lib/svnjavahl.jar
ln -s %{_javadir}/svnkit.jar $RPM_BUILD_ROOT%{core_plugin_dir}/lib/svnkit.jar
ln -s %{_javadir}/ganymed-ssh2.jar $RPM_BUILD_ROOT%{core_plugin_dir}/lib/ganymed.jar
%if %{gcj_support}


%post -p %{_bindir}/rebuild-gcj-db
%postun -p %{_bindir}/rebuild-gcj-db
%endif

%files
%{install_loc}/subclipse
%doc svnClientAdapter/readme.txt svnClientAdapter/changelog.txt svnClientAdapter/license.txt 
%if %{gcj_support}
%{_libdir}/gcj/%{name}
%endif

%files book
%{install_loc}/subclipse-book

%changelog
* Fri Jan 02 2009 Igor Vlasenko <viy@altlinux.ru> 1.2.4-alt2_12jpp6
- new version

* Mon Jul 28 2008 Igor Vlasenko <viy@altlinux.ru> 1.2.4-alt2_11jpp6
- eclipse 3.3.2

* Sat Dec 01 2007 Igor Vlasenko <viy@altlinux.ru> 1.2.4-alt2_5jpp5.0
- fixed unmet dependency on svn-javahl

* Fri Nov 30 2007 Igor Vlasenko <viy@altlinux.ru> 1.2.4-alt1_5jpp5.0
- converted from JPackage by jppimport script

